/*

	here's a simple example of structure fmt_option:

        static struct fmt_option opts[] = {
          { 't', "title" },
          { 'a', "artist" },
          { 'l', "album" },
          { 'r', "track" },
          { 'y', "year" },
          { 'g', "genre" },
          { 'c', "comment" },
          { 0, 0 }
        };

	then

        fmtstr(b, "%x .%%. %a - %l - %t.mp3", opts);

	will produce "%x .%. artist - album - title.mp3" on b. 
	
*/

#ifndef __FMTSTR__
#define __FMTSTR__

#include <stdio.h>
#include <stdlib.h>
#include "fmtstr.h"

#ifdef __cplusplus
extern "C" {
#endif

struct fmt_option {
	int opt;
	const char *str;
};

void fmtstr(char *dest, const char *src, const struct fmt_option *opts);

#ifdef __cplusplus
};
#endif

#endif
