#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <xmms/util.h>
#include <libsap.h>
#include "insap.h"
#include "sap.h"
#include "insap_about.h"

void insap_about(void)
{
	static GtkWidget *box = NULL;
	
	#ifdef __DEBUG__
	MESGB(__FILE__,__LINE__) "ABOUT\n" MESGE
	#endif

	if (box) return;
	
	box = xmms_show_message(
		"About " INSAP_STR " " INSAP_VER,
		"written by Mike Kunikowski <kunik@priv3.onet.pl>\n\n"
		"This software is written using " LIBSAP_PORT_INFO " of\n"
		LIBSAP_INFO "\n\n"
		"SAP Library is a software emulation of CPU 6502 microprocessor and Pokey chip.\n"
		"Those two chips are used in Atari XL/XE computers. SAP Library is used to run\n"
		"programs written in 6502 machine language, programs that are using Pokey chip\n"
		"to play tunes and sounds.\n\n"
		"You may found some (or many) sap files at:\n"
		"http://asma.dspaudio.com (ASMA homepage)\n"
		"http://mp3.musichall.cz/Unreal/ASMA (ASMA homepage - czech mirror)\n"
		"http://asma.nea.pl (ASMA homepage - polish mirror)\n\n"
		"Number of seconds in xmms counters means a number of subtunes\n"
		"and changing tune time switches between subtunes",
		"Close",
		FALSE, NULL, NULL);
	gtk_signal_connect(GTK_OBJECT(box), "destroy",
			   gtk_widget_destroyed, &box);
}
