#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include "insap.h"
#include "sap.h"
#include "insap_fileinfo.h"

static GtkWidget *fileinfo_win = NULL;

void insap_fileinfo(gchar *filename)
{
	GtkWidget *vbox, *label;
	gint i;
	gchar *tmp;
	char a[1024], b[1024];

	#ifdef __DEBUG__
	MESGB(__FILE__,__LINE__) "FILE_INFO: %s\n",filename MESGE
	#endif

	if (fileinfo_win) return;
	fileinfo_win = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_signal_connect(GTK_OBJECT(fileinfo_win), "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroyed), &fileinfo_win);
	
	tmp = g_strdup_printf("File Info - %s", g_basename(filename));
	gtk_window_set_title(GTK_WINDOW(fileinfo_win), tmp);
	g_free(tmp);
	gtk_window_set_policy(GTK_WINDOW(fileinfo_win), FALSE, FALSE, FALSE);
	gtk_window_set_position(GTK_WINDOW(fileinfo_win), GTK_WIN_POS_NONE);
	gtk_container_border_width(GTK_CONTAINER(fileinfo_win), 10);

	vbox = gtk_hbox_new(FALSE, 10);
	gtk_container_add(GTK_CONTAINER(fileinfo_win), vbox);
	
	strcpy(a, "");
	strcpy(b, "");
	readSapComment(filename);
	setSapCommentArray(NULL);
	for (i=0; sapCommentTab[i][0]!=NULL; i++) {
		strcat(a, sapCommentTab[i][0]);
		strcat(b, sapCommentTab[i][1]);
		if (sapCommentTab[i+1][0]!=NULL) {
			strcat(a, "\n");
			strcat(b, "\n");
		}
	}
	
	label = gtk_label_new(a);
	gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_RIGHT);
	gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
	gtk_widget_show(label);

	label = gtk_label_new(b);
	gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
	gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
	gtk_widget_show(label);
		
	gtk_widget_show(vbox);
	gtk_widget_show(fileinfo_win);
}
