#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#include "sap.h"

#define MAX_SAP_COMMENT_ENTRYS 16

char *sapCommentTab[MAX_SAP_COMMENT_ENTRYS][2];
static char commentbuf[512];

int isSapFile(const char *filename)
{
	char buf[3];
	int fd, i;
	
	fd = open(filename, O_RDONLY);
	if (fd < 0) return 0;
	i=read(fd, buf, 3);
	close(fd);
	if (i!=3) return 0;
	
	return (strncmp(buf, "SAP", 3)==0);
}

int readSapComment(const char *filename)
{
	static unsigned char buf[128];
	int fd, r, cp, i;
	
	fd = open(filename, O_RDONLY);
	if (fd < 0) return 0;
	
	r = read(fd, buf, 3);
	if (r!=3||strncmp(buf, "SAP", 3)!=0) {
		close(fd);
		return 0;
	}
	
	cp = 0;
	while (1) {
		r = read(fd, buf, sizeof buf);
		if (r<=0) goto endofloop;
		for (i=0; i<r; i++) {
			if (buf[i]==255) goto endofloop;
			commentbuf[cp++]=buf[i];
		}
	}
	endofloop:
	
	commentbuf[cp]='\0';
	close(fd);
	
	return 1;
}

void setSapCommentArray(char *comment)
{
	int i, j, cp;

	if (comment==NULL) comment = commentbuf;
	
	i = 0;
	cp = 0;
	while (i<MAX_SAP_COMMENT_ENTRYS) {
		while (isspace(comment[cp])) cp++;
		sapCommentTab[i][0]=&comment[cp];
		while (comment[cp]!='\0' && comment[cp]!=13 && comment[cp]!=10) cp++;
		if (comment[cp]=='\0') break;
		comment[cp]='\0';
		cp++;
		i++;
	}
	sapCommentTab[i][0]=NULL;
	sapCommentTab[MAX_SAP_COMMENT_ENTRYS-1][0]=NULL;
	
	for (i=0; i<MAX_SAP_COMMENT_ENTRYS && sapCommentTab[i][0]!=NULL; i++) {
		j=0;
		while (sapCommentTab[i][0][j]!='\0' && !isspace(sapCommentTab[i][0][j])) j++;
		if (sapCommentTab[i][0][j]!='\0') sapCommentTab[i][0][j++]='\0';
		if (sapCommentTab[i][0][j]=='"') j++;
		sapCommentTab[i][1]=&sapCommentTab[i][0][j];
		if (sapCommentTab[i][1][strlen(sapCommentTab[i][1])-1]=='"')
			sapCommentTab[i][1][strlen(sapCommentTab[i][1])-1]='\0';
	}
}

char *getSapCommentElem(char *key)
{
	int i;
	for (i=0; i<MAX_SAP_COMMENT_ENTRYS && sapCommentTab[i][0]!=NULL; i++)
		if (strcmp(sapCommentTab[i][0], key)==0) return sapCommentTab[i][1];
	return "";
}

/*
char *getSapCommentElem(char *dest, char *comment, char *key)
{
	int i,j;
	char *p;

	if ((p=strstr(comment, key))==NULL) {
		strcpy(dest, "");
		return dest;
	}
	
	p+=strlen(key);
	while (isspace(p[0])) p++;
	for (i=0; p[i]!=13&&p[i]!=10; i++) dest[i] = p[i];
	dest[i]='\0';
	for (i=strlen(dest)-1; i>=0&&isspace(dest[i]); i--) dest[i]='\0';
	if (dest[0]=='"'&&dest[strlen(dest)-1]=='"') {
		dest[strlen(dest)-1]='\0';
		for (i=1,j=strlen(dest); i<=j; i++) dest[i-1]=dest[i];
	}
	
	return dest;
}
*/
